<template>
  <div class="mx-auto mt-5 flex w-full flex-col gap-y-5">
    <SStatusMessage v-if="status.show" :variant="status.variant" :title="status.title">
      {{ status.description }}
    </SStatusMessage>
    <div class="flex flex-col gap-y-3">
      <Dropzone @change="handleFileUpload" :disabled="isUploading" />
      <div v-if="uploadedFile !== null" class="flex flex-col gap-y-5">
        <SJsonPreviewExpandable v-if="uploadedFileContent" :content="uploadedFileContent" />
        <div class="flex flex-row items-center">
          <SButton class="w-auto border p-2" @click="uploadFile" :disabled="isUploading">
            Publish to catalogue
          </SButton>
          <SLoadingSpinner v-if="isUploading" name="spinner" class="ml-4" />
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { uploadSelfDescription } from '../../services/federatedCatalogue';
import { getFileExtension } from '../../util/files';
import SButton from '../common/SButton.vue';
import SLoadingSpinner from '../common/SLoadingSpinner.vue';
import SStatusMessage, { type MessageVariant } from '../common/SStatusMessage.vue';
import Dropzone from './Dropzone.vue';
import SJsonPreviewExpandable from '../common/SJsonPreviewExpandable.vue';

const uploadedFile = ref<null | File>(null);
const uploadedFileContent = defineModel<string>({ default: '' });

const keycloakToken = ref<string | null>(null);

const isUploading = ref(false);

const defaultStatus = {
  show: false,
  variant: 'information' as MessageVariant,
  title: '',
  description: '',
};

const status = ref(defaultStatus);

const resetStatus = () => {
  status.value = defaultStatus;
};

onMounted(async () => {
  resetStatus();
  keycloakToken.value = window.localStorage.getItem('KEYCLOAK_ACCESS_TOKEN');
});

const setPreviewValue = (value: string) => {
  uploadedFileContent.value = value;
};

const handleFileUpload = (event: Event) => {
  resetStatus();
  setPreviewValue('');
  const fileInput = event.target as HTMLInputElement;
  if (!fileInput.files?.length) {
    uploadedFile.value = null;
    return;
  }

  if (fileInput.files[0].type !== 'application/json') {
    if (getFileExtension(fileInput.files[0].name).match(/json/) === null) {
      status.value = {
        show: true,
        variant: 'error',
        title: 'File format is invalid',
        description:
          'File cannot be uploaded. Only json and jsonld files are allowed. Please upload file with the correct format',
      };
      return;
    }
  }

  uploadedFile.value = fileInput.files[0];

  const reader = new FileReader();

  reader.addEventListener('load', (event: Event) => {
    const result = (event.target as FileReader).result;

    if (!isValidJSON(result as string)) {
      status.value = {
        show: true,
        variant: 'error',
        title: 'File contains invalid JSON',
        description: "File cannot be uploaded. Please check the file's contents",
      };
      uploadedFile.value = null;
      return;
    }

    setPreviewValue(result as string);
  });
  reader.readAsText(uploadedFile.value);
};

const uploadFile = async (event: Event) => {
  if (uploadedFile.value === null) {
    return;
  }

  isUploading.value = true;

  try {
    if (!keycloakToken.value) {
      return;
    }
    const response = await uploadSelfDescription(uploadedFileContent.value, keycloakToken.value);
    const data = await response.json();

    if (response.status === 201) {
      status.value = {
        show: true,
        variant: 'success',
        title: 'Publishing successful',
        description: 'The self description has been published to the catalogue successfully',
      };
    } else {
      status.value = {
        show: true,
        variant: 'error',
        title: 'Publishing failed',
        description: `An error occured during the publishing process\n${data.message}`,
      };
    }
  } catch (err) {
    status.value = {
      show: true,
      variant: 'error',
      title: 'Publishing failed',
      description: `An error occured during the publishing process\n${err}`,
    };
    console.error(err);
  } finally {
    isUploading.value = false;
  }
};

const isValidJSON = (JSONstring: string) => {
  try {
    JSON.parse(JSONstring);
    return true;
  } catch (err) {
    return false;
  }
};
</script>
